function solverState = unpackState(stateVector, time, solverStateOriginal)
% unpack state vector according to packing parameters
%
% THIS IS NO USER FUNCTION

% The elk-library: convex geometry applied to crystallization modeling.
%   Copyright (C) 2012 Alexander Reinhold
%
% This program is free software: you can redistribute it and/or modify it 
%   under the terms of the GNU General Public License as published by the 
%   Free Software Foundation, either version 3 of the License, or (at your 
%   option) any later version.
%
% This program is distributed in the hope that it will be useful, but 
%   WITHOUT ANY WARRANTY; without even the implied warranty of 
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
%   General Public License for more details.
%
% You should have received a copy of the GNU General Public License along 
%   with this program.  If not, see <http://www.gnu.org/licenses/>.

%% init
% some numbers
nBulkState = size(solverStateOriginal.bulkStateVector, 1);
nDim = size(solverStateOriginal.hcMatrix, 1);
nPivot = size(solverStateOriginal.hcMatrix, 2);

% use a central definition of al properly sorted fields
solverState = obtainCleanSolverState;
% time
solverState.time = time;
solverState.bulkStateVector = zeros(0,1);
solverState.hcMatrix = zeros(nDim, 0);
solverState.numberVector = zeros(1, 0);
solverState.upVector = solverStateOriginal.upVector;
solverState.flagDensity = solverStateOriginal.flagDensity;
if solverState.flagDensity
    solverState.probabilityVector = zeros(1, 0);
end
solverState.flagNucleation = solverStateOriginal.flagNucleation;
solverState.indexVector = solverStateOriginal.indexVector;
solverState.dissolvedPivotVector = solverStateOriginal.dissolvedPivotVector;

stateVectorSize = nBulkState + nPivot*(nDim + 1 + solverState.flagDensity);


%% pivots
if solverState.flagDensity
    stateMatrix = reshape(stateVector(1:(stateVectorSize - nBulkState)), ...
        nDim + 2, nPivot);
    solverState.hcMatrix = stateMatrix(1:nDim, :);
    solverState.numberVector = stateMatrix(end-1, :);
    solverState.probabilityVector = stateMatrix(end, :);
else
    stateMatrix = reshape(stateVector(1:(stateVectorSize - nBulkState)), ...
        nDim + 1, nPivot);
    solverState.hcMatrix = stateMatrix(1:nDim, :);
    solverState.numberVector = stateMatrix(end, :);
end

%% bulk states
if nBulkState > 0
    solverState.bulkStateVector = stateVector((end-nBulkState+1):end, 1);
end